from tkinter.ttk import Treeview
from tkinter.messagebox import *
import pymysql, datetime, database
from tkinter import *

import requests

from GetLog.GetLog import method
class mainWindow():
    def __init__(self):
        self.mainwin = Tk()
        method.tk_size(win=self.mainwin, ww=850, wh=500, xr=2, yr=2, t='天气')
        global EntryCity, textinfo, tree
        Label(self.mainwin, text='城市:').place(x=20, y=10)
        EntryCity = Entry(self.mainwin)
        EntryCity.place(x=60, y=10)
        self.yscroll = Scrollbar(self.mainwin)  # 滚动条
        self.yscroll.place(x=820, y=80, width=25, height=330)
        self.x_scroll = Scrollbar(self.mainwin, orient=HORIZONTAL)
        self.x_scroll.place(x=10, y=400, width=800, height=20)
        cloums_key = ["日期", "星期", "更新时间", "城市", "天气", "实时温度", "风向", "风力等级", "风速", "湿度", "能见度", "气压", '空气质量', "pm2.5", "空气等级", "提示"]
        tree = Treeview(self.mainwin, columns=cloums_key, show="headings", xscrollcommand=self.x_scroll.set)
        tree.place(x=20, y=100, height=300, width=800)
        for c_name in cloums_key:
            tree.heading(c_name, text=c_name)
            tree.column(c_name, anchor=CENTER, width=80)
        self.yscroll.config(command=tree.yview)
        self.x_scroll.config(command=tree.xview)
        Button(self.mainwin, text='远程获取', command=lambda: self.get_now()).place(x=80, y=60)
        Button(self.mainwin, text='查询本地', command=lambda: self.querylocal()).place(x=280, y=10, height=21, width=60)
        Button(self.mainwin, text='本地所有', command=lambda: self.queryall()).place(x=380, y=10, height=21, width=60)
        self.queryall()
        self.mainwin.mainloop()
  #  def clounm(self):
        # sql = 'SELECT COLUMN_NAME  FROM information_schema.columns WHERE table_name="GetWeather"'
        # r = str((database.query(sql)))
        # s = r.replace('(', '').replace(')', '').replace(',', '').replace('\'', '')
        # t = s.split(' ')
        # return t
    def queryall(self):
        sql = "select date,week,update_time,city,wea,tem,win,win_speed,win_meter,humidity,visibility,pressure,air ,air_pm25,air_level,air_tips from GetWeather order by date"
        sql2 = "select date,week,update_time,city,wea,tem,win,win_speed,win_meter,humidity,visibility,pressure,air ,air_pm25,air_level,air_tips from GetWeather2 order by date"
        result = database.query(sql)
        result2 = database.query(sql2)
        if len(tree.get_children()) > 0:
            for it in tree.get_children():
                tree.delete(it)
        for it in result:  # 遍历行
            tree.insert("", END, value=it)
        for it in result2:  # 遍历行
             tree.insert("", END, value=it)
    def querylocal(self):
        c = EntryCity.get()
        if self.check_entry() == False:
            print(False)
        else:
            result = database.query("select * from GetWeather where city = %s",  c)
            result2 = database.query("select date,week,update_time,city,wea,tem,win,win_speed,win_meter,humidity,visibility,pressure,air ,air_pm25,air_level,air_tips from GetWeather2 where city = %s", c)
            if len(tree.get_children()) > 0:
                for it in tree.get_children():
                    tree.delete(it)
            for it in result:  # 遍历行
                tree.insert("", END, value=it)
            for it in result2:  # 遍历行
                tree.insert("", END, value=it)
    def get_api(self):
        city = EntryCity.get()
        url = 'https://v0.yiketianqi.com/api?unescape=1&version=v61&appid=37883155&appsecret=M5bGQst5&city=%s' % city
        req = requests.get(url, timeout=30)  # 请求连接
        api_info = req.json()  # 获取数据
        print(api_info)
        return api_info
    def info_item(self,k):
        req_jason = self.get_api()
        COLstr = ''  # 列的字段
        COLstr2 = ''
        ROWstr = ''  # 行字段
        ColumnStyle = ' nvarchar(200)'
        for key in req_jason.keys():
            values = req_jason[key]
            if ':' in values:
                str = values.replace(':', '-')
                ROWstr = ROWstr + "\"%s\"" % (str) + ','
                COLstr = COLstr + ' ' + key + ColumnStyle + ','
                COLstr2 = COLstr2 + ' ' + key + ','
            elif values == '':
                COLstr = COLstr + ' ' + key + ColumnStyle + ','
                COLstr2 = COLstr2 + ' ' + key + ','
                values = 'null'
                ROWstr = ROWstr + "\"%s\"" % (values) + ','
            elif isinstance(values, dict):
                for i in values:
                    COLstr = COLstr + 'l2_' + i + ColumnStyle + ','
                    COLstr2 = COLstr2 + 'l2_' + i + ','
                    v2 = values[i]
                    if v2 == '':
                        v2 = 'null'
                        ROWstr = ROWstr + "\"%s\"" % (v2) + ','
                    elif v2 == '[]':
                        pass
                    else:
                        ROWstr = ROWstr + "\"%s\"" % (v2) + ','
            else:
                COLstr = COLstr + ' ' + key + ColumnStyle + ','
                COLstr2 = COLstr2 + ' ' + key + ','
                ROWstr = ROWstr + '' + "\"%s\"" % (values) + ','
        cloums_key = COLstr2.split(",")
        print(COLstr)
        if k == 1:
            return cloums_key
        if k == 2:
            return COLstr
        if k == 3:
            return COLstr2
        if k == 4:
            return ROWstr
    def check_entry(self):
        city = EntryCity.get()
        if city == '':
            showinfo('提示', '请输入城市！')
            return False
    def get_now(self):
        timenow = datetime.datetime.now().strftime('%Y-%m-%d')
        t = "\"%s\""%(timenow)
        city = EntryCity.get()
        c = "\"%s\"" %(city)
        self.check_entry()
        sql1 = 'select date from GetWeather where city = %s  ' % c
        sql2 = 'select date from GetWeather2 where city = %s  ' % c
        db = database.open()  # 连接数据库
        cursor = db.cursor()  # 使用cursor()方法获取操作游标
        result = database.query(sql1)
        result2 = database.query(sql2)
        r = str(result)
        r2 = str(result2)
        print(r)
        print(r2)
        r2 = str(result2)
        if timenow in r:
            showinfo('提示', '当日天气已存在，请查看下方表格！')
            self.querylocal()
        else:
            COLstr = self.info_item(k=2)
            COLstr2 = self.info_item(k=3)
            ROWstr = self.info_item(k=4)
            print(COLstr)
            k = "api"
            if k in COLstr:
                print("meiyou")
                sql3 = 'CREATE TABLE IF NOT EXISTS GetWeather2 (%s c_time nvarchar(200))' % COLstr
                cursor.execute(sql3)
                sql4 = 'INSERT INTO  GetWeather2(%s c_time) values(%s %s)' % (COLstr2, ROWstr, t)
                print(sql4)
                cursor.execute(sql4)
            else:
                print("you")
                sql = 'CREATE TABLE IF NOT EXISTS GetWeather (%s c_time nvarchar(200))' % COLstr
                cursor.execute(sql)
                sql2 = 'INSERT INTO  GetWeather(%s c_time) values(%s %s)' % (COLstr2, ROWstr, t)
                print(sql2)
                cursor.execute(sql2)
            db.commit()
            db.close()
        self.queryall()










mainWindow()